#include "xservergrabber.h"
#include <QByteArray>
#include <QX11Info>
#include <QDebug>
#include <X11/Xlib.h>
#include <xcb/xcb.h>
namespace NSS {

static bool grabKeyboard()
{
    int rv = XGrabKeyboard( QX11Info::display(), QX11Info::appRootWindow(),
                            True, GrabModeAsync, GrabModeAsync, CurrentTime );

    return (rv == GrabSuccess);
}

static bool grabMouse()
{
#define GRABEVENTS ButtonPressMask | ButtonReleaseMask | PointerMotionMask | \
    EnterWindowMask | LeaveWindowMask
    int rv = XGrabPointer( QX11Info::display(), QX11Info::appRootWindow(),
                           True, GRABEVENTS, GrabModeAsync, GrabModeAsync, None,
                           None, CurrentTime );
#undef GRABEVENTS

    return (rv == GrabSuccess);
}

class XServerGrabber
{
public:
    XServerGrabber() {
        xcb_grab_server(QX11Info::connection());
    }
    ~XServerGrabber() {
        xcb_ungrab_server(QX11Info::connection());
        xcb_flush(QX11Info::connection());
    }
};
bool closeGrab()
{
    XSync(QX11Info::display(), False);
    XServerGrabber xserverGraber;

    Q_UNUSED(xserverGraber)

    XUngrabKeyboard(QX11Info::display(), CurrentTime);
    XUngrabPointer(QX11Info::display(), CurrentTime);
    XFlush(QX11Info::display());
    return true;
}
bool establishGrab()
{
    if (!QX11Info::isPlatformX11()) {
        return true;
    }
    XWindowAttributes rootAttr;
    XGetWindowAttributes(QX11Info::display(), QX11Info::appRootWindow(), &rootAttr);
    XSelectInput( QX11Info::display(), QX11Info::appRootWindow(),
                        SubstructureNotifyMask|rootAttr.your_event_mask );
    XSync(QX11Info::display(), False);
    XServerGrabber serverGrabber;
    if (!grabKeyboard()) {
        qWarning() << "grab Keyborad failed!";
        return false;
    }

    if (!grabMouse()) {
        qWarning() << "grab Mouse failed!";
        XUngrabKeyboard(QX11Info::display(), CurrentTime);
        XFlush(QX11Info::display());
        return false;
    }
    return true;
}
}
