#ifndef IDLEWATCHER_H
#define IDLEWATCHER_H

#include <QObject>

class IdleWatcher : public QObject
{
    Q_OBJECT
public:
    explicit IdleWatcher(int secs, QObject *parent = nullptr);
    virtual ~IdleWatcher();
public Q_SLOTS:
    void reset(int secs);
    void removeIdleTimeout();
private Q_SLOTS:
    void onResumingFromIdle();
    void onTimeoutReached(int identifier);
    void setup();

Q_SIGNALS:
    void requestLock();

private:
    int mSecs;
    int mIdentifier { 0 };
};

#endif // IDLEWATCHER_H
