#include "lockscreenshortcut.h"
#include <nde-globalkeys.h>
#include <QDebug>

namespace NSS {
#define DEFAULT_SHORTCUT "Control+Alt+L"
#define DEFAULT_SHORTCUT_1 "Meta+L"
LockScreenShortcut::LockScreenShortcut(QObject *parent) : QObject(parent)
{
    mLockShortcut = GlobalKeyShortcut::Client::instance()->addAction(
                QString(), QString("/nde/screensaver/greeter"), tr("Activate Lock Screen"), this);
    if (mLockShortcut)
    {
        connect(mLockShortcut, &GlobalKeyShortcut::Action::registrationFinished, this, [=]{
            if (mLockShortcut->shortcut().isEmpty())
            {
                mLockShortcut->changeShortcut(DEFAULT_SHORTCUT);
            }
        });
        connect(mLockShortcut, SIGNAL(activated()), this, SIGNAL(globalKeyActivated()));
    }

    mLockShortcut1 = GlobalKeyShortcut::Client::instance()->addAction(
                QString(), QString("/nde/screensaver/greeter1"), tr("Activate Lock Screen"), this);
    if(mLockShortcut1)
    {
        connect(mLockShortcut1, &GlobalKeyShortcut::Action::registrationFinished, [this] {
            if(mLockShortcut1->shortcut().isEmpty())
                mLockShortcut1->changeShortcut(DEFAULT_SHORTCUT_1);
        });
        connect(mLockShortcut1, SIGNAL(activated()), this, SIGNAL(globalKeyActivated()));
    }
}
}
