#include "screensaver.h"
#include "screensaveradaptor.h"
#include "ScreenSaverApp.h"

ScreenSaver::ScreenSaver(QObject *parent) : QObject(parent)
{
    new ScreenSaverAdaptor(this);
    if (!QDBusConnection::sessionBus().isConnected()) {
        qWarning() << "Cannot connect to the D-Bus session bus.";
    }

    if (!QDBusConnection::sessionBus().registerService(QStringLiteral("org.nde.ScreenSaver"))) {
        qWarning() << QDBusConnection::systemBus().lastError().message();
    }
    QDBusConnection::sessionBus().registerObject(QStringLiteral("/ScreenSaver"), QStringLiteral("org.nde.ScreenSaver"), this);
}

void ScreenSaver::lock()
{
    NSS::SaverApp->lockSession();
}
void ScreenSaver::setIdleTime(int secs)
{
    QSettings setting("nde", "screensaver");
    setting.setValue("idleTime", secs);
    NSS::SaverApp->setIdleTime(secs);
}
bool ScreenSaver::getLockState()
{
    return NSS::SaverApp->locked();
}

